=== debian/changelog ===
sleef (3.9.0-1) unstable; urgency=medium

  * Team upload.
  * d/watch: switch to version 5.
  * New upstream version 3.9.0.
  * d/patches: refresh existing patches.
  * d/control: bump std-ver to 4.7.2 (no changes required).
  * d/rules:
    + use ninja as cmake backend.
    + disable tlfloat library.
    + disable tests on armel.
  * d/tests: add test name and link to libm.

 -- Shengqi Chen <harry@debian.org>  Fri, 24 Oct 2025 18:47:51 +0800
