=== debian/tests/control ===
Test-Command: gcc docs/sophomore.c -lsleef -lm -o sophomore && ./sophomore
Depends: libsleef-dev, build-essential,
Restrictions: skippable
Architecture: any
Features: test-name=docs-sophomore

Test-Command: if test $(dpkg --print-architecture) = 'amd64'; then true; else exit 77; fi;
 gcc docs/hellox86.c -lsleef -lm -o hellox86; ./hellox86;
Depends: libsleef-dev, build-essential,
Restrictions: skippable
Architecture: amd64
Features: test-name=docs-hellox86
